#include <stdio.h>
#include <dlfcn.h>

main()
{
	void	*handle;
	int	result, (*func)(char*);

	/*
	**	initialize function status to zero
	*/

	result = 0;

	/*
	**	open DSO, return error if unable to locate it
	*/

	if ((handle=dlopen("./testlib.so",RTLD_LAZY)) == NULL)
	{
		printf("dlopen : unable to open DSO\n");
		exit(1);
	}

	/*
	**	look up function in DSO and assign to function pointer
	*/

	if ((func=(int(*)(char*))dlsym(handle,"printstring")) == NULL)
	{
		printf("dlsym : unable to locate function\n");
		exit(1);
	}

	/*
	**	jump to function and execute; return status
	*/

	result = (*func)("this is a test string");

	/*
	**	check function return status and print message
	*/

	if (result)
		printf("\nSuccessfully completed dlopen test\n");
	else
		printf("\nAn error occurred in DSO function\n");

	/*
	**	unload (close) DSO and exit
	*/

	dlclose(handle);
	exit(0);
}
