
     crpt(1)                   UNIX System V                   crpt(1)

     NAME
          crpt - generate a kernel core file report

     SYNOPSIS
          crpt [-n] N
          crpt [-n] unix.N vmcore.N
          crpt [-n] unix.N vmcore.N.comp

     DESCRIPTION
          crpt generates a report from kernel core files that can aid
          your support provider in determining the cause of a system
          crash.  The report is saved in current directory as
          crashN.rpt (Where "N" is the number of the dump file as
          specified by /usr/adm/crash/bounds).

          When a system crashes, it saves the contents of physical
          memory and a copy of the kernel that was running.  savecore
          places these files in /usr/adm/crash.  If your system has
          crashed and you do not have unix.N and vmcore.N in
          /usr/adm/crash, see savecore(1M)).  The dbx(1) debugger must
          be installed for crpt to run.  crpt drives the dbx debugger
          through the basic steps a kernel expert would start with
          when debugging a system crash.  After generating a report,
          don't delete unix.N and vmcore.N.  They may be needed if in
          depth debugging is required.  Usually only a kernel expert
          with access to the SGI source code can accurately debug
          these core files. Please give this report to your service
          provideer when openning a call about a crashing system.
          This report can be attached to service calls logged via
          escall(1).

          crpt provides the following information:

          o  The full path of the core files.  Output from the utsname
             data structure.

          o  If the script is run on the crashing system, it will
             provide additional hardware and software information.
             The output from "hinv" and "versions -b" will be
             incorporated into the report.

          o  Formatted output from the kernel's error buffer.  The
             "putbuf" contains errors messages that are flushed to the
             system's error log (/usr/adm/SYSLOG), but this buffer
             sometimes not flushed to the logfile when the system
             crashes.

          o  The name of the program that was running at the time of
             the crash and the process id of that program.

          o  A kernel stack trace.  This will help trace the functions
             called which lead up to the crash.  The routine below the

     Page 1                                           (printed 4/1/94)

     crpt(1)                   UNIX System V                   crpt(1)

             "trap()" function is the routine where the exception
             occurred.

          o  NMI (Non-maskable Interrupt) Registers are printed for
             each CPU if the system is intentionally halted with the
             NMI switch.

          o  Disassembled code surrounding the exception program
             counter.  This will output the name of the routine the
             system crashed in and the line number in the source code.
             The operation the system crashed on will be labeled
             EXCEPTION.

     OPTIONS
          Command line options are described below.

          -n   Turns on netstat -m and -s reports

     SEE ALSO
          savecore(1M), uncompvm(1M), dbx(1), netstat(1) escall(1)

     Page 2                                           (printed 4/1/94)
