/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef __GIZMO_H__
#define __GIZMO_H__

#define GIZMO_MASTER	1234

/* GIZMO BLOCK STUFF */
typedef struct Gizmofblock {
    char		*name;			/* name of window 	*/
    char		*iconname;		/* name of icon		*/
    void		(*initwidgets)();
    long		(*initsubwindow)();	/* init for subwin or 0	*/
    void		(*activatewidgets)();
    void		(*drawwidgets)();
    void		(*drawsubwindow)();
    long		(*interpclick)(long, long, long, long);
    long		(*interpchar)(long);
    long		(*interpother)(long, long);
    void		(*locatemouse)(long, long);
    long		(*readfromsocket)(long);
    long		(*getheight)();
    long		(*getwidth)();
} gfblock_t;

typedef struct gizmo {
	char 	name[128];
	int	fd;
	int	pid;
	long	llx;
	long	lly; 
	long	xsize;
	long	ysize; 
	long	state;
	void	(*initme)();
	void	(*killme)();
    	struct gizmo	*next;
} gizmo_t;

#define GIZMOSTATE_CLOSED   0
#define GIZMOSTATE_OPEN     1
#define GIZMOSTATE_STOWED   2

/* devices for reiniting the browsegizmo */

#define ABORT	    	    20002
#define	GIZMOINITEND	    20136
#define	BUTTONSTRDEV	    20143	
#define	TITLESTRDEV	    20144
#define	ACCEPTSTRDEV	    20145
#define	REINITEND	    20146
#define FILENAMEDEV         20082
#define	CREATEDEV           20083
#define	POKEGIZMO           20086
#define	DIRNAMEDEV	    20094
#define	GIZMOXORG	    20095
#define	GIZMOYORG	    20096
#define	QUITGIZMO	    20097
#define MESSAGEDEV  	    20014

void opengizmo(long);
void murdergizmos();
long cookedqread(long *);

#endif
