/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#include <gl.h>
#include <device.h>
#include "gizmo.h"
#include "../generic.h"

void	initwidgetsmaster();
void	activatewidgetsmaster();
void	drawwidgetsmaster();
long	getheightmaster();
long	getwidthmaster();
long	interpclickmaster(long, long, long, long);
long	interpcharmaster(long);
long	interpothermaster(long, long);
void	locatemousemaster(long, long);
long	readfromsocketmaster(long);
long	sendpair(long, long);

gfblock_t	mastergfb = {
	"Master Gizmo",
	"Master",
	initwidgetsmaster,
	0,
	activatewidgetsmaster,
	drawwidgetsmaster,
	0,
	interpclickmaster,
	interpcharmaster,
	interpothermaster,
	locatemousemaster,
	readfromsocketmaster,
	getheightmaster,
	getwidthmaster,
};

gfblock_t	*gfb = &mastergfb;
long		gizmonumber = GIZMO_MASTER;
extern  long    gizllx, gizlly;

long
getheightmaster()
{
    return 100;		/* YWSIZE */
}

long
getwidthmaster()
{
    return 291;	    	/* XWSIZE */
}


void
initwidgetsmaster()
{
}

void
activatewidgetsmaster()
{
}

void
drawwidgetsmaster()
{
    color(WHITE); clear();
    color(BLACK);
    cmov2i(10, 20);
    charstr("Type character to touch file");
}

long
interpclickmaster(long mx, long my, long dev, long val)
{
	return 0;
}

long
interpothermaster(long dev, long val)
{
    return 0;
}

long
interpcharmaster(long val)
{
    sendpair(TOUCHME, 0);
}

void
locatemousemaster(long mx, long my)
{
}

long
readfromsocketmaster(long dev)
{
	return 1;
}

setenable()
{
}

turnoffchecks()
{
}
