/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef __stacktrace_h_
#define __stacktrace_h_

#   ifdef __cplusplus
    extern "C" {
#   endif

	/* XXX some of this is defunct */

	extern void initstacktrace(char **argv);
	extern int stacktrace (char *filename, int startpc, int startsp,
			       int regs[], int (*getword)(unsigned));
	extern int stacktrace_print(int skip);

	extern int stacktrace_get(int skip, int n, void *trace[]);
	extern int simple_stacktrace_write(int fd, char *fmt, char *executable,
							int n, void *trace[]);
	extern int simple_stacktrace_print(int fd, char *fmt, int skip, int n);
	extern void stacktrace_cleanup();
	extern char *stacktrace_get_argv0();
	extern void stacktrace_set_argv0(const char *);
	extern char *stacktrace_get_executable();
	extern void stacktrace_set_executable(const char *);

	extern void stacktrace_get_ffl(void *pc,
				       char *fun, char *file, int *line,
				       int funbufsiz, int filebufsiz);

#   ifdef __cplusplus
    }
#   endif

#endif /* __stacktrace_h_ */
